//"32CH Programmable Sequencer". On the basis of Arduino the controler.  
//The author of the program alexval2007, Asstoxa , Open_Pyro.  V8,2 (14.11.2010)  
//******************************************************************************************************
// История версий:
//V8,2 (14.11.20010) alexval2007
//    - Убрал проблему с задержками для формирования импульсов на сдвиговые регистры изза высокой тактовой частоты мк
//      регистры неуспевали переключатся заменил функцию asm("nop"); на delay(1); полёт нормальный
//V8,1 (07.10.20010) alexval2007
//    - В начале кода переделал некоторые переменные в #define для уменьшения занимаемого места в коде в результате
//      сэкономил целых 3байта во как для меги 8 это важно мало места. Убрал по коду еще несколько косячков мелких с
//      инициализацией, а также выкинул лишние задержки.
// V8 (06.10.20010) Open_Pyro
//    - Поправил цикл вывода в регистр теперь работают все 32 канала. ПО уарту передает "CueDelay[y]+CueHIGH_delay"
//      задержку между запусками каналов в мсек.
//
// V7 (06.10.20010) alexval2007
//
// V6 (04.10.20010) Open_Pyro
// 1. Изменен тип переменных:  
//     - там где число явно не будет выходит за предел 255 используется "unsigned char"
//     - изменен тип хранения данных "CueDelay[32]" времени задержки между запусками каналов с "int"  
//       (максимальное значение 32 768 или 32.8 сек задержки) на "unsigned long" которое возможно в  
//       в функции "delay()" (максимальное значение 4 294 967 296 или 4294967.2 сек задержки).
//
// 2. Из функции "void shiftOut(int myDataPin, int myClockPin, unsigned long myDataOut)" выкинул передаваемые      
//    параметры ножек "myDataPin" и "myClockPin", так как регистры у нас подключены на фиксированные ножки МК.  
//    Функция теперь имеет вид "void shiftOut( unsigned long myDataOut)", а выводы инициализируемый при старте  
//    процессора. Что ускоряет работу и уменьшает код.
//
// 3. "Подготавливаем регистр к приёму данных" и "Защелкиваем данные в регистре" перенесено в функцию
//    "void shiftOut( unsigned long myDataOut)".
//
// 4. Теперь выходы не работают постоянно в состоянии "1" а обнуляются перед запуском следующего канала.
//    Так же заработала временная задержка "Время импульса на воспламенители ххх мсек."
//
// 5. По тексту программы добавлены описания и пояснения, а тек же отформатирован код для лучшей читаемости.
//**************************************************************************************************************** 
   #define CueHIGH 100 // Время импульса на воспламенители ххх мсек.  
//----------------------------------------------------------------------------------------------------------------    
   #define Cue1 40     // Время задержки между запусками первого и следующего за ним канала в ххх мсек  
   #define Cue2 140    // то Cue1 должно иметь значение 400 мсек (500 мсек - 100 мсек = 400 мсек)  
   #define Cue3 140
   #define Cue4 40
   #define Cue5 140
   #define Cue6 40
   #define Cue7 40
   #define Cue8 40
   #define Cue9 140
   #define Cue10 40
   #define Cue11 40
   #define Cue12 140
   #define Cue13 40
   #define Cue14 40
   #define Cue15 140
   #define Cue16 40
   #define Cue17 140
   #define Cue18 140
   #define Cue19 40
   #define Cue20 140
   #define Cue21 40
   #define Cue22 140
   #define Cue23 40
   #define Cue24 140
   #define Cue25 40
   #define Cue26 140
   #define Cue27 40
   #define Cue28 140
   #define Cue29 40
   #define Cue30 240
   #define Cue31 140
   #define Cue32 40  
//******************************************************************************************************   
    unsigned char dataPin  = 2;  // Подключаем вывод к DS of 74HC595 данные 
    #define clockPin 3           // Подключаем вывод к SH_CP of 74HC595 тактовые импульсы
    #define latchPin 4           // Подключаем вывод к ST_CP of 74HC595 защёлка
    #define BUTTON   19          // Вход кнопки "старт"

// Обявляю переменные и массивы       
   unsigned long data = 0;       // Переменная состоит из 4 байт которые пишутся в 4-ре регистра
   unsigned long data1 = 0;      // Переменная состоит из 4 байт которые пишутся в 4-ре регистра
   unsigned char val = 0;        // Переменная состояния кнопки
   unsigned int y;               // Переменные циклов
   int pinState;
   unsigned long CueHIGH_delay = CueHIGH; //  Время импульса на воспламенители
   unsigned long CueDelay[32] = { Cue1,  Cue2,  Cue3,  Cue4,  Cue5,  Cue6,  Cue7,  Cue8,  Cue9,  Cue10,  
                    Cue11, Cue12, Cue13, Cue14, Cue15, Cue16, Cue17, Cue18, Cue19, Cue20,
                    Cue21, Cue22, Cue23, Cue24, Cue25, Cue26, Cue27, Cue28, Cue29, Cue30,  
                    Cue31, Cue32}; // Масив со временем задержки между включением каналов за вычетом времени
                                   // импульса на воспламенители
//******************************************************************************************************  
// Инициализация ***************************************************************************************  
   void setup(){  
     pinMode(BUTTON , INPUT);      // Настраиваю Pin на ввод
     pinMode(dataPin, OUTPUT);     // Настраиваем порты сдвигового регистра на вывод  
     pinMode(latchPin, OUTPUT);   
     pinMode(clockPin, OUTPUT);  
//**********************************      
     digitalWrite(dataPin, LOW);    // Обнуляем порты сдвигового регистра
     digitalWrite(latchPin, LOW);  
     digitalWrite(clockPin, LOW);     
     digitalWrite(BUTTON, HIGH);   // Включаю подтягивающий резистор по входу к лог 1
//**********************************      
     Serial.begin(9600);            // Скорость обмена по UART  
     Serial.println("TEST HELLO");  // Тестовое сообщение отправляемое по UART      
//**********************************    
     send_data(0); // Данные пишутся в регистр (все биты "0")  
   }  
//**Основной цикл ***************************************************************************************
   void loop(){ 
     val = digitalRead(BUTTON); // Обработка состояния пускового входного сигнала
     if (val == LOW){  
//********************************************  
     data1 = 1;
     for (y=0; y<32; y++){
      Serial.println(CueDelay[y]+CueHIGH_delay);  
      send_data(data1);        // Ставим ножку в единицу
      delay(CueHIGH_delay);    // Время импульса на воспламенители  
      send_data(0);            // Сбрасываем ножку  
      delay(CueDelay[y]);
      data1=(data1<<1);  
     }          
//*******************************************      
   }else{           // иначе
    send_data(0);  //  Обнуление регистров.  Данные пишутся в регистр (все биты "0").  
   delay(1);
  }
}   
//******************************************************************************************************
//Подпрограмма вывода на сдвиговый регистр *************************************************************  
     void send_data (unsigned long data){
     unsigned char i;
       for (i=0;i<32;i++){
   if ((data&0x80000000)==0x00) PORTD&=~_BV(dataPin); // Выводим данные на dataPin 
          else PORTD|=_BV(dataPin);
          delay(1);
          PORTD|=_BV(clockPin); // Импульс на CLK Даем один тактовый импульс
          delay(1);
          PORTD&=~_BV(clockPin);
          delay(1);
          data=(data<<1);
       } 
       PORTD|=_BV(latchPin); // Даем Импульс на Latch защелкиваем данные в регистрах
       delay(1);
       PORTD&=~_BV(latchPin);
      }    
//******************************************************************************************************
